(* ------------------------------------------------------ *)
(*                   PASDEMO.PAS                          *)
(*     Demoprogramm, zeigt aus Basic umgewandelte Daten   *)
(* ------------------------------------------------------ *)
PROGRAM PasDemo;

USES CRT;

TYPE TempDaten = RECORD
                   Vorname  : STRING [10];
                   NachName : STRING [20];
                   Plz      : INTEGER;
                   LongIn   : LongInt;
                   EReal    : Single;          (* !! *)
                   Doppelt  : Double;
                 END;
VAR  DemoDaten : TempDaten;
     DemoFile  : FILE OF TempDaten;

(* ------------------------------------------------------ *)
PROCEDURE DatLoad;
VAR Fn : STRING [12];

BEGIN
  Fn := 'PasDatei.DAT';
  Assign(DemoFile, Fn);
(*$I-*)
  Reset(DemoFile);
(*$I+*)
  Seek(DemoFile, 0);            (* Im Beispiel : 0 .. 2 *)
  Read(DemoFile, DemoDaten);
  Close(DemoFile);
END;

(* ------------------------------------------------------ *)
BEGIN
  FillChar(DemoDaten, SizeOf(DemoDaten), 0);
  ClrScr;
  DatLoad;
  WriteLn(DemoDaten.Vorname);
  WriteLn(DemoDaten.Nachname);
  WriteLn(DemoDaten.Plz);
  WriteLn(DemoDaten.LongIn);
  WriteLn(DemoDaten.EReal);
  WriteLn(DemoDaten.Doppelt);
END.
